PAT 1030 Travel Plan[图论][难]
1030 Travel Plan (30)(30 分)
A traveler's map gives the distances between cities along the highways, together with the cost of each highway. Now you are supposed to write a program to help a traveler to decide the shortest path between his/her starting city and the destination. If such a shortest path is not unique, you are supposed to output the one with the minimum cost, which is guaranteed to be unique.
Input Specification:
Each input file contains one test case. Each case starts with a line containing 4 positive integers N, M, S, and D, where N (<=500) is the number of cities (and hence the cities are numbered from 0 to N-1); M is the number of highways; S and D are the starting and the destination cities, respectively. Then M lines follow, each provides the information of a highway, in the format:
City1 City2 Distance Cost
where the numbers are all integers no more than 500, and are separated by a space.
Output Specification:
For each test case, print in one line the cities along the shortest path from the starting point to the destination, followed by the total distance and the total cost of the path. The numbers must be separated by a space and there must be no extra space at the end of output.
Sample Input
4 5 0 3
0 1 1 20
1 3 2 30
0 3 4 10
0 2 2 20
2 3 1 20
Sample Output
0 2 3 3 40
题目大意:给出起点和终点,找出起点和终点之间的所有最短路径,并且cost最小。每条边有两个属性,一个是距离,一个是花费。
// 这个就是迪杰斯特拉裸题,我一定要做出来,见过多少次这样的题了。
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define INF 999999
int edge[][];
int cost[][];
int dist[],co[];
bool vis[];
int pre[];
vector<int> path;
int main() {
int n,m,s,d;
cin>>n>>m>>s>>d;
int f,t,e,c;
fill(cost[],cost[]+*,INF);//二维数组必须用cost[0],而不能用cost。
fill(edge[],edge[]+*,INF);//这么多初始化有点烦。
for(int i=;i<m;i++){
cin>>f>>t>>e>>c;
edge[f][t]=edge[t][f]=e;
cost[f][t]=cost[t][f]=c;
}
fill(dist,dist+n,INF);
fill(co,co+n,INF);
fill(pre,pre+n,);
for(int i=;i<n;i++){
if(edge[s][i]!=)
dist[i]=edge[s][i];//初始化
if(cost[s][i]!=)
co[i]=cost[s][i];
}
//选出距离s最近的点。 dist[s]=;
vis[s]=true;
pre[s]=-;
int u=-,minn=INF;
for(int i=;i<n;i++){
u=-,minn=INF;
for(int j=;j<n;j++){
if(!vis[j]&&dist[j]<minn){
minn=dist[j];
u=j;
}
}
if(u==-||u==d)break;
vis[u]=true;
for(int j=;j<n;j++){
if(!vis[j]){
if(dist[j]>dist[u]+edge[u][j]){
dist[j]=dist[u]+edge[u][j];
pre[j]=u;
co[j]=co[u]+cost[u][j];
}else if(dist[j]==dist[u]+edge[u][j]){
if(co[j]>co[u]+cost[u][j]){
pre[j]=u;
co[j]=co[u]+cost[u][j];
}
}
}
}
}
path.push_back(d);
u=d;
while(pre[u]!=-){
path.push_back(pre[u]);
u=pre[u];
}//s不用再单独push了。
for(int i=path.size()-;i>=;i--){
cout<<path[i]<<" ";
}
cout<<dist[d]<<" "<<co[d]; return ;
}
//第一次我是这么写的,但是提示内存超限。需要改进啊。原来考点在这个地方啊,又是考内存。内存超限:您的程序使用了超过限制的内存。case通过率为30.00%
都改成了vector加上resize,也不行,也是超时。
//代码来自:https://www.liuchuo.net/archives/2369 十分值得学习,原来用dfs即可遍历。
#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;
int n, m, s, d;
int e[][], dis[], cost[][];
vector<int> pre[];//四个二维,一个一维
bool visit[];
const int inf = ;
vector<int> path, temppath;
int mincost = inf;
void dfs(int v) {//原来可以用向量来保存前驱,以前想到过但是不会实现。原来使用dfs.
temppath.push_back(v);
if(v == s) {
int tempcost = ;
for(int i = temppath.size() - ; i > ; i--) {
int id = temppath[i], nextid = temppath[i-];
tempcost += cost[id][nextid];
}
if(tempcost < mincost) {
mincost = tempcost;
path = temppath;//直接对一个向量赋值,即可。
}
temppath.pop_back();
return ;
}
for(int i = ; i < pre[v].size(); i++)
dfs(pre[v][i]);
temppath.pop_back();//最终把自己弹了出来。
}
int main() {
fill(e[], e[] + * , inf);
fill(dis, dis + , inf);
scanf("%d%d%d%d", &n, &m, &s, &d);
for(int i = ; i < m; i++) {
int a, b;
scanf("%d%d", &a, &b);
scanf("%d", &e[a][b]);
e[b][a] = e[a][b];
scanf("%d", &cost[a][b]);
cost[b][a] = cost[a][b];
}
pre[s].push_back(s);//s的前驱是s自己。
dis[s] = ;
for(int i = ; i < n; i++) {
int u = -, minn = inf;
for(int j = ; j < n; j++) {
if(visit[j] == false && dis[j] < minn) {
u = j;
minn = dis[j];
}
}
if(u == -) break;
visit[u] = true;
for(int v = ; v < n; v++) {
if(visit[v] == false && e[u][v] != inf) {
if(dis[v] > dis[u] + e[u][v]) {
dis[v] = dis[u] + e[u][v];
pre[v].clear();
pre[v].push_back(u);
} else if(dis[v] == dis[u] + e[u][v]) {
pre[v].push_back(u);
}
}
}
}
dfs(d);
for(int i = path.size() - ; i >= ; i--)
printf("%d ", path[i]);
printf("%d %d", dis[d], mincost);
return ;
}
//我也不知道我改了什么,把自己的代码修好了。就最后循环出路径的while循环修改了,其他都没动,开心。
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define INF 99999
int edge[][];
int cost[][];
int dist[],co[];
bool vis[];
int pre[];
vector<int> path;
//两个二维矩阵,4个一维矩阵,一个向量。
int main() {
int n,m,s,d;
cin>>n>>m>>s>>d;
int f,t,e,c;
fill(cost[],cost[]+*,INF);//二维数组必须用cost[0],而不能用cost。
fill(edge[],edge[]+*,INF);//这么多初始化有点烦。
for(int i=;i<m;i++){
cin>>f>>t>>e>>c;
edge[f][t]=edge[t][f]=e;
cost[f][t]=cost[t][f]=c;
}
fill(dist,dist+n,INF);
fill(co,co+n,INF);
fill(pre,pre+n,-);//要全初始化为-1
//选出距离s最近的点。
dist[s]=;
co[s]=;
int u,minn;
for(int i=;i<n;i++){
u=-,minn=INF;
for(int j=;j<n;j++){
if(!vis[j]&&dist[j]<minn){
minn=dist[j];
u=j;
}
}
if(u==-||u==d)break;
vis[u]=true;
for(int j=;j<n;j++){
if(!vis[j]&&edge[u][j]!=INF){
if(dist[j]>dist[u]+edge[u][j]){
dist[j]=dist[u]+edge[u][j];
pre[j]=u;
co[j]=co[u]+cost[u][j];
}else if(dist[j]==dist[u]+edge[u][j]){
if(co[j]>co[u]+cost[u][j]){
pre[j]=u;
co[j]=co[u]+cost[u][j];
}
}
}
}
}
u=d;
while(u!=-){
path.push_back(u);
u=pre[u];
}//s不用再单独push了。
for(int i=path.size()-;i>=;i--){
cout<<path[i]<<" ";
}
cout<<dist[d]<<" "<<co[d]; return ;
}
PAT 1030 Travel Plan[图论][难]的更多相关文章
- PAT 1030 Travel Plan
#include <cstdio> #include <cstdlib> #include <vector> #include <queue> #inc ...
- PAT 甲级 1030 Travel Plan (30 分)(dijstra,较简单,但要注意是从0到n-1)
1030 Travel Plan (30 分) A traveler's map gives the distances between cities along the highways, to ...
- 1030 Travel Plan (30 分)
1030 Travel Plan (30 分) A traveler's map gives the distances between cities along the highways, toge ...
- [图算法] 1030. Travel Plan (30)
1030. Travel Plan (30) A traveler's map gives the distances between cities along the highways, toget ...
- PAT A 1030. Travel Plan (30)【最短路径】
https://www.patest.cn/contests/pat-a-practise/1030 找最短路,如果有多条找最小消耗的,相当于找两次最短路,可以直接dfs,数据小不会超时. #incl ...
- PAT (Advanced Level) 1030. Travel Plan (30)
先处理出最短路上的边.变成一个DAG,然后在DAG上进行DFS. #include<iostream> #include<cstring> #include<cmath& ...
- PAT甲题题解-1030. Travel Plan (30)-最短路+输出路径
模板题最短路+输出路径如果最短路不唯一,输出cost最小的 #include <iostream> #include <cstdio> #include <algorit ...
- PAT 甲级 1030 Travel Plan
https://pintia.cn/problem-sets/994805342720868352/problems/994805464397627392 A traveler's map gives ...
- 【PAT甲级】1030 Travel Plan (30 分)(SPFA,DFS)
题意: 输入N,M,S,D(N,M<=500,0<S,D<N),接下来M行输入一条边的起点,终点,通过时间和通过花费.求花费最小的最短路,输入这条路径包含起点终点,通过时间和通过花费 ...
随机推荐
- Android开发训练之第五章第五节——Resolving Cloud Save Conflicts
Resolving Cloud Save Conflicts IN THIS DOCUMENT Get Notified of Conflicts Handle the Simple Cases De ...
- 【SpringBoot整合Elasticsearch】SpringBoot整合ElasticSearch
一.Linux下安装ElasticSearch 1.检测是否安装了Elasticsearch ps aux |grep elasticsearch 2.安装JDK 3.下载Elasticsearch ...
- junit4 详解
转:http://www.cnblogs.com/eggbucket/archive/2012/02/02/2335697.html JUnit4概述 JUnit4是JUnit框架有史以来的最大改进, ...
- Makefile伪目标
https://www.zybuluo.com/lishuhuakai/note/210174 本节我们讨论一个Makefile中的一个重要的特殊目标:伪目标. 伪目标是这样一个目标:它不代表一个真正 ...
- LeetCode 48 Rotate Image(2D图像旋转问题)
题目链接: https://leetcode.com/problems/rotate-image/?tab=Description Problem:给定一个n*n的二维图片,将这个二维图片按照顺时 ...
- Windows Phone 8.1 Update Preview backup失败的解决方法
当前使用的是开发者预览版(8.10.14219.341),最近一直无法备份text + apps + settings,进度条达到97%或99%以后提示: There was a problem ba ...
- 笨鸟就要勤奋&专注
最近两天在找工作的过程中颇受打击,两家高大上的公司看起来就是要收集世界上最聪明的人~,在参加G家的online test之前还天真的认为一不小心通过了怎么办呢?考完试之后才发现真的是想多了,关于题目看 ...
- .sh 的运行
cat *.sh 看一下你的那个sh文件 看第一行是#!/bin/bash 还果 #!/bin/sh 如果是/bin/bash就执行 bash your.sh 如果是/bin/sh 就执行 sh yo ...
- jenkins中Email Extersion Plugin插件使用说明点
在jenkins中使用第3方邮件插件Email Extersion Plugin时,根据网上教程,发现每次都没有生成模板 再次查看,发现 $HOME_jenkins下没有templeate文件夹,查阅 ...
- python selenium操作表格式元素实例
很多时候,网页上的布局都是表格形式的,如出下面这样的 这种网页类型在自动化中比较头痛,需要很多判断,下面就举个例子,这里以深圳出入境网页为例,http://yysl.sz3e.com/wsyysq/s ...